gap.test <- function( ru, alpha, beta, t, n ) {
    chisq = 0
    s <- 0
    j <- 1 
    l = length(ru)
    count1 <- rep(0, t+1)
    if( ( l * (beta - alpha) * (1 - (beta - alpha) ) ^ t) < 5 ) {
        stop("Insert a smaller value of t")
    } else {
        while(s < n) {
            r <- 0
            while( ru[j] < alpha  ||  ru[j] >= beta ){
                r = r + 1
                j = j + 1 
            }
            if(r > 0 && r < t) {
                count1[r+1] = count1[r+1] + 1
                s = s + 1
            }
            if (r >= t){
                count1[t+1] = count1[t+1] + 1
                s = s + 1
            }
            r <- 0
            if( ru[j] >= alpha  &&  ru[j] < beta ) {
                if(ru[j+1] >= alpha && ru[j+1] < beta ) {
                    count1[1] = count1[1] + 1
                    s = s + 1
                }  else {
                    while( ru[j+1] < alpha  ||  ru[j+1] >= beta ) {
                        r = r + 1
                        j = j + 1
                    }
                }
                if(r > 0  &&  r < t) {
                    count1[r+1] = count1[r+1] + 1
                    s = s + 1
                }
                if( r >= t ){
                    count1[t+1] = count1[t+1] + 1
                    s = s + 1
                }
            }
            j <- j + 1
        }
    }
    print( count1 )
    p = (beta - alpha)
    for( i in 1:(t+1) )
        chisq = chisq +
            (count1[i] - n*p*((1-p)^(i-1)))^2 /
                ( n*p*((1-p)^(i-1)) )
    print(chisq)
    if( pchisq(chisq, df = t) > 0.05 ) {
        print("The given sequence of numbers is random")
    }  else
    print("The given sequence of numbers is not random")
}


## gap.test(runif(20000),0.11,0.83,3,15)
