
serial.correlation.test <- function(x, a = 0.05) {
    n  = length(x)
    y  = c( x[-1], x[1] )
    C  = cor( x,y )
    EC = -1/(n-1)
    VC = (n*n) / ( (n-1) * (n-1) * (n-2) )
    T  = abs( (C - EC) / sqrt(VC) )
    if(a != 0.05) {
        a = a
    } else
    a = 0.05
    T_tab = qnorm( 1 - (a/2) )
    if(T > T_tab) {
        con = "The Sample Is Not Random"
    } else
    con = "The Sample Is Random"
    con
}

