serial.test <- function(ru,d) {
    chisq = 0
    count <- matrix(0, nrow = d, ncol = d)
    ry = floor(ru*d)
    k = d*d
    n = floor( length(ru)/2 )
    if( n < (5*k) ) {
        stop("NEED LARGER SAMPLE OR A SMALLER VALUE OF d")
    }  else {
        for( p in 0:(d-1) ) {
            for ( q in 0:(d-1)) {
                for (j in 0:(n-1)) {
                    if( ry[(2*j) + 1] == p   &&   ry[(2*j) + 2] == q )
                        count[p+1,q+1] = count[p+1,q+1] + 1
                }
            }
        }
    }
    print(count)
    for( p in 0:(d-1) ) {
        for( q in 0:(d-1) ) {
            chisq = chisq + ( count[p+1, q+1] - (n/k) )  *  ( count[p+1, q+1] - (n/k) ) / (n/k)
        }
    }
    print(chisq)
    if( pchisq( chisq, df = k-1 ) > 0.05 ) {
        print("The sequence is random")
    }  else
    print("The sequence is not random")
}

## serial.test(runif(10000),30)

